{ config, pkgs, lib, self, ... }:
with lib;
let
  psCfg = config.pub-solar;
  xdg = config.home-manager.users."${psCfg.user.name}".xdg;
in
{
  imports = [
    ./hardware-configuration.nix
  ];

  config = {
    age.secrets.environment-secrets = {
      file = "${self}/secrets/environment-secrets.age";
      mode = "700";
      owner = "teutat3s";
    };

    pub-solar.nextcloud.enable = mkForce false;
    pub-solar.docker.enable = mkForce false;
    pub-solar.virtualisation.enable = true;

    home-manager.users."${psCfg.user.name}".xdg.configFile = mkIf psCfg.sway.enable {
      "sway/config.d/10-custom-keybindings.conf".source = ./.config/sway/config.d/custom-keybindings.conf;
      "sway/config.d/autostart.conf".source = ./.config/sway/config.d/autostart.conf;
      "sway/config.d/input-defaults.conf".source = ./.config/sway/config.d/input-defaults.conf;
      "sway/config.d/screens.conf".source = ./.config/sway/config.d/screens.conf;
    };
  };
}
